/*
 * Main.java
 *
 * Created on July 20, 2005, 11:00 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeserver;

import java.util.*;

interface ProgramConstants
{
    public static final int boardMaxX = 41 - 1;
    public static final int boardMaxY = 33 - 1;
    
    public static final int snakeDelta = 1;
    
    public static final int numFoodPieces = 3;
    public static final int timerFireIncriment = 100;
}


/**
 *
 * @author Administrator
 */
public class Main {
    
    /** Creates a new instance of Main */
    public Main() {
        
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        System.out.print("start of program!!\n");
        
        //create SnakeMatrix
        SnakeMatrix snakematrix = new SnakeMatrix();
        
        
        //create Game listener
        GameListener gListener = null;
        try {
            //init GameListener
            gListener = new GameListener(30060);
            
            
            //start Game listener
            new Thread(gListener).start();
            
            //set Game Listener's referance to SnakeMatrix
            gListener.snakematrix = snakematrix;
            
        }
        catch (Exception E)
        {
            System.out.print("Something went wrong during GameListener startup\n");
            System.exit(-1);
        }
        /*
        for(int x=0;x<1000;x++)
                System.out.print("main thread!!!!!!!!!!!!!!!!\n");
        */
        
        //create and initialize the timer class
        Reminder sendGameData = new Reminder(ProgramConstants.timerFireIncriment,gListener);
        
        
        //Idea:  Maybe make a JFrame window that does the following:  testframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        // so that the program cant accidently remain open and tie up the socket
        
        
        /*
        Timer timer = new Timer();
        timer.schedule(new Reminder(),1000);
        */
        //RemindTask.class
       
    }


}


