/*
 * Snake.java
 *
 * Created on July 21, 2005, 4:53 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeserver;

import java.util.*;
/**
 *
 * @author Administrator
 */
public class Snake {
    
    private int direction;
    private int direction_at_last_move;
    public String ip;
    public String playerName;
    private Vector pieces;
    
    private boolean bdeservesfood;
    
    private boolean bskipnextstrech = false;
    //private int bdeservescount=0;
    
    /** Creates a new instance of Snake */
    public Snake(String newip) {
        ip = newip;
        pieces = new Vector(20);
    }
    
    public void setDirection(int newDirection){
        
        
        //check for directions that would make a snake turn back on itself
        //DVB 20080731 bug fix - sometimes, the user can be fast and the snake can still double back on itself
        //check against 'direction_at_last_move' instead of 'direction'
        switch(newDirection)
        {
            case 0:     //up
                if (direction_at_last_move == 2) //disallow down
                    return;
                break;
            case 1:     //right
                if (direction_at_last_move == 3) //disallow left
                    return;
                break;
            case 2:     //down
                if (direction_at_last_move == 0) //disallow up
                    return;
                break;
            case 3:     //left
                if (direction_at_last_move == 1) //disallow right
                    return;
                break;
        }
        
        /*
        //check for directions that would make a snake turn back on itself
        switch(newDirection)
        {
            case 0:     //up
                if (direction == 2) //disallow down
                    return;
                break;
            case 1:     //right
                if (direction == 3) //disallow left
                    return;
                break;
            case 2:     //down
                if (direction == 0) //disallow up
                    return;
                break;
            case 3:     //left
                if (direction == 1) //disallow right
                    return;
                break;
        }
        
        */
        
        
        direction = newDirection;
        
    }
    
    public void setNewRandomCoordsAndDirection(){
        //clear the snake's body
        pieces.clear();
        
        Random generator = new Random();
        
        direction = generator.nextInt(4);     
        
        //pieces.add(makeRandomSnakePiece());
        pieces.add(new SnakePiece(generator.nextInt(ProgramConstants.boardMaxX),generator.nextInt(ProgramConstants.boardMaxY)));
        
    }
    
    public static SnakePiece makeRandomSnakePiece(){
        Random generator = new Random();
        return(new SnakePiece(generator.nextInt(ProgramConstants.boardMaxX),generator.nextInt(ProgramConstants.boardMaxY)));    
    }

    public void moveWholeSnakeOneSpace()
    {
        //move each section of the snake to its predec
        //0 is the index for the front of the snake
        
        //create a new snakepiece in front
        //TODO: implement bounds checking for running into walls.  Maybe do it somewhere else
        
        SnakePiece currentSnakeHead = (SnakePiece)pieces.firstElement();
        int curX = currentSnakeHead.x;
        int curY = currentSnakeHead.y;
        
        switch(direction)
        {
            case 0: //move snake up
                curY = curY - ProgramConstants.snakeDelta;
                break;
            case 1: //move snake right
                curX = curX + ProgramConstants.snakeDelta;
                break;
            case 2: //move snake down
                curY = curY + ProgramConstants.snakeDelta;
                break;
            case 3: //move snake left
                curX = curX - ProgramConstants.snakeDelta;
                break;
        }
        
        
        if (bdeservesfood==true)
        {
            //stick the new one in the front spot
            pieces.add(0,new SnakePiece(curX,curY));
            bdeservesfood = false; //remove to make long snake
        }
        else
        {
            //move all the pieces up one.
            for(int x=pieces.size()-1; x>0;x--)
            {
                pieces.set(x, pieces.get(x-1));
            }
            pieces.set(0, new SnakePiece(curX, curY));
        }
        
        
        direction_at_last_move = direction;
        
        /*
        //move everybody up one place
        //if (bdeservesfood==true)
        //{
            //add an element at the rear of the vector after moving everyone forward
        Vector oldpieces = copyVector(pieces);
        
        SnakePiece rearmost = (SnakePiece)pieces.elementAt(pieces.size() - 1);            
        
        pieces.remove(0);
        
        for(int x=0;x<pieces.size();x++)
            if(x!=pieces.size())
                pieces.set(x, x+1);
        
        pieces.add(0, new SnakePiece(curX,curY));
        
        
        if(bdeservesfood)
        {
            pieces.add(rearmost);
            bdeservesfood = false;
        }
        */
        
        //if(pieces.addElement(rearmost);
        /*
        SnakePiece rearmost = (SnakePiece)pieces.elementAt(pieces.size() - 1);            
        //}
        
        SnakePiece tempSnakePiece = null;
        for(int x=0; x < pieces.size(); x++)
        {
            tempSnakePiece = (SnakePiece)pieces.get(x);
            if(x==0)
            {
                //special case for first piece, use new coordinates
                pieces.setElementAt(new SnakePiece(curX,curY), x);
            }
            else
            {
                pieces.setElementAt(tempSnakePiece, x);
            }
        }
        if (bdeservesfood==true){
            pieces.add(rearmost);
            bdeservesfood = false;
        }
        
    */


//insert the new snake head
        







        //pieces.insertElementAt(new SnakePiece(curX, curY), 0);
         
        
        //iterate through the snake and make everyone have the coordinates of
        // the snake piece in front of them
        //skip the first piece
        /*
        if(bskipnextstrech == true)
        {
            bskipnextstrech = false;
        }
        else
        {
            int piecessize = pieces.size();
            for(int curPieceIndex=1; curPieceIndex<pieces.size() - 1 ; curPieceIndex++)
            {
                SnakePiece currentpiece = (SnakePiece)pieces.elementAt(curPieceIndex);
                SnakePiece nextpiece = (SnakePiece)pieces.elementAt(curPieceIndex + 1);

                //if(bdeservesfood!=true)
                pieces.set(curPieceIndex, nextpiece);
                //((SnakePiece)pieces.elementAt(curPieceIndex)).x = ((SnakePiece)pieces.elementAt(curPieceIndex + 1)).x; 
                //((SnakePiece)pieces.elementAt(curPieceIndex)).y = ((SnakePiece)pieces.elementAt(curPieceIndex + 1)).y; 


            }
        }
  
       
        //delete the old tail unless the snake deserves food
        
        if (bdeservesfood==true)
        {
            //let the tail live!
            bdeservesfood = false;
            bskipnextstrech = true;
        }
        else{
            //lop off that tail!!
            pieces.removeElementAt(pieces.size() - 1);
        }
         
        */
        
    }

    public int getSize(){
        return(pieces.size());
    }
    
    public SnakePiece getSnakePiece(int index){
        return (SnakePiece)pieces.get(index);
    }
    
    public void setDeservesFood(boolean newbdeservesfood){
        bdeservesfood = newbdeservesfood;
    }
    public Vector copyVector(Vector toCopy){
        int newvectorsize = toCopy.size();
        
        Vector newVector = new Vector();
        for(int x=0;x<newvectorsize;x++)
        {
            newVector.add(toCopy.get(x));
        }
        return newVector;
        
        
        
    }
}
