/*
 * ClientSocketClass.java
 *
 * Created on July 25, 2005, 5:19 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeclient;

import java.io.IOException;
import java.net.*;
import java.net.DatagramPacket;

/**
 *
 * @author user
 */
public class ClientSocketClass extends DatagramSocket implements Runnable{
    MainGameWindow maingamewin;
    
    /** Creates a new instance of ClientSocketClass */
    public ClientSocketClass() throws IOException{
        super(30061);
    }
    
    public void startListening(){
        //block on a new packet coming in
        DatagramPacket p = new DatagramPacket(new byte[1024],1024);
        
        //System.out.print("tempbyte is:" + tempbyte.toString() + "\n");
        System.out.print("Blocking on recieve() method...\n");
        
        while(true)
        {
            try{
                receive(p);

                int len = p.getLength();
                String s = new String(p.getData(),0,len);
                
                parsePacket(s);
                
                //moveAllSnakesAndSendAllCurrentGameData();
                //System.out.print("got a packet from:" + p.getAddress().getHostAddress() + " length=" + len + " data=" + s + "\n");

            }
            catch(Exception E){
                System.out.print("ERRORCould not recieve Datagrampacket.");
            }
        }
    }
    
    public void parsePacket(String s){
        
        //Switch on snake move packet
        switch (s.charAt(0))
        {
            case 's': //snake message
                
                maingamewin.drawSnakesFromPacket(s.substring(1));
                
                break;
                
            case 'f':
                
                maingamewin.drawFoodFromPacket(s.substring(1));
                break;
                
            
        }
        
    }
    public void setReferences(MainGameWindow newmaingamewin){
        maingamewin = newmaingamewin;
    }
    
    
    public void run(){
        startListening();
    }
    
    public void sendData(String s){
        
        
        //DatagramPacket p = new DatagramPacket(buf,len,inetaddy,port)
        try{
            InetAddress temp = InetAddress.getByName(maingamewin.serverAddress);
            byte [] tb = new byte[s.length()];
            tb = s.getBytes();
            DatagramPacket p = new DatagramPacket(tb,s.length(),temp, 30060);
            
            send(p);
            
        }
        catch(Exception e){
            int foobar = 0;
        }
        
                //= DatagramPacket(s.toCharArray(),s.length(), temp,30060);
        
        
    }
    
    
}
