/*
 * MainGameWindow.java
 *
 * Created on July 25, 2005, 4:31 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeclient;

import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.event.KeyAdapter;
import java.awt.geom.Rectangle2D;
import javax.swing.JFrame;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.net.*;
import java.awt.*;
/**
 *
 * @author user
 */
public class MainGameWindow extends JFrame{
    
    ClientSocketClass clientsocket;
    public String serverAddress;
    Graphics2D g;
    
    
    Color colors[] = new Color[10];
    
    /** Creates a new instance of MainGameWindow */
    public MainGameWindow() {
        
        super("NetNibbles Client");
        this.setBackground(Color.WHITE);
        
        initEverything();
    
        //instantiate predefined colors
        colors[0] = Color.BLACK;
        colors[1] = Color.BLUE;
        colors[2] = Color.RED;
        colors[3] = Color.CYAN;
        colors[4] = Color.GRAY;
        colors[5] = Color.DARK_GRAY;
        colors[6] = Color.GREEN;
        colors[7] = Color.MAGENTA;
        colors[8] = Color.ORANGE;
        colors[9] = Color.PINK;
        //colors[10] = Color.WHITE;
        
        
        g = (Graphics2D)this.getGraphics();
        
        
        try{
            clientsocket = new ClientSocketClass();
        }
        catch(Exception e){
            
        }
        
        
        
    }
    
    public void setServerAddress(String newserverAddress){
        serverAddress = newserverAddress;
    }
    public void setReferences(ClientSocketClass newclientsocket){
        clientsocket = newclientsocket;
    }
    public void initEverything(){
        setSize(600, 375);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setLocation(300, 100);
        setVisible(true);
        
        //windowEvents testWindowEvents = new windowEvents();
        //windowEvents
        addKeyListener(new KeyAdapter(){
            
            public void keyPressed(KeyEvent e){
                
                //a key was pressed
                
                //testing drawing board boundries
                //g.drawLine(10, 10, 500,500);

                
                
                //(x-offset,y-offset
                
                int myKeyCode = e.getKeyCode();
                if (myKeyCode==e.VK_UP)
                {
                    clientsocket.sendData("d0");
                    
                }
                else if(myKeyCode==e.VK_RIGHT)
                {
                    clientsocket.sendData("d1");
                }
                else if(myKeyCode==e.VK_DOWN)
                {
                    clientsocket.sendData("d2");
                }
                else if(myKeyCode==e.VK_LEFT)
                {
                    clientsocket.sendData("d3");
                }
                else
                {
                    //do nothing                   
                }

        
           }});
        
        
        
        //testframe.addKeyListener(keysPressed);
    }
    /*
    public void sendDataToClientSocketClass(String S){
        //this is a strange workaround because I cannot directly access the 
        // local instance of ClientSocketClass (called clientsocket) from within
        // the JFrame keyPressed event.  I am doing this in another place too.
        clientsocket.send
        
    }
     **/
    public void drawSnakesFromPacket(String S){
        //clear the entire form
       g.clearRect(0, 0, getWidth(), getHeight());
       
       String [] snakemessage;
       String [] pieces;
       snakemessage = S.split(",");
       String thissection = null;
       int curx=0;
       int cury=0;
       
       int curpiece = 1; //the current piece of the message
       
       //number of snakes
       int numsnakes = Integer.valueOf(snakemessage[curpiece++]);
       
       for(int x=0;x <= numsnakes;x++)
       {
           //int numsections = curpiece++;
           int numsections = Integer.valueOf(snakemessage[curpiece++]);
           for(int sect=1; sect <= numsections; sect++)
           {
               //get the coords of the individual sections and draw them
               thissection = snakemessage[curpiece++];
               pieces = thissection.split("-");
               
               curx = Integer.valueOf(pieces[0]);
               cury = Integer.valueOf(pieces[1]);
               
               g.setColor(colors[x % 11]);
               g.draw(new Rectangle(curx * ProgramConstants.snakeSideSizepx + ProgramConstants.xOffset,
                                    cury * ProgramConstants.snakeSideSizepx + ProgramConstants.yOffset,
                                    ProgramConstants.snakeSideSizepx,
                                    ProgramConstants.snakeSideSizepx)
                       );
               
               //write the coords of this snake to the screen
               //g.drawString("Location: " + curx + "," + cury ,60,60);
               g.drawRect(10,30,410, 330);
           }
       }
    }
     
    public void drawFoodFromPacket(String S){
        String [] foodmessage = S.split(",");
        
        int numfoodpieces = Integer.valueOf(foodmessage[1]);
        
        String [] curcoords;
        int curx,cury;
        for(int curfoodpiece=2; curfoodpiece < numfoodpieces + 2; curfoodpiece++) //we're starting 2 places into the array of strings ;-p
        {
            curcoords = foodmessage[curfoodpiece].split("-");
            curx = Integer.valueOf(curcoords[0]);
            cury = Integer.valueOf(curcoords[1]);
            
            g.setColor(Color.RED);
            
            g.drawRect(curx * ProgramConstants.snakeSideSizepx + ProgramConstants.xOffset + 2, cury * ProgramConstants.snakeSideSizepx + ProgramConstants.yOffset + 2, 2, 2);
        }
        
    }
    
    //just pass the data to send to the client socket, i was too lazy to create a reference
    public void sendDataProxyWTF(String data){
        clientsocket.sendData(data);
    }
    

}
