/*
 * GameListener.java
 *
 * Created on July 20, 2005, 11:10 PM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package snakeserver;
import java.io.IOException;
import java.net.*;

/**
 *
 * @author Administrator
 */


public class GameListener extends java.net.DatagramSocket implements Runnable{
    
    /** Creates a new instance of GameListener */
    
    //referance to SnakeMatrix class
    SnakeMatrix snakematrix;
    
    public GameListener(int fart) throws IOException{
        //DatagramSocket test = new DatagramSocket(port);
        //super.
        
        super(fart);
        //setReuseAddress(true);
        //close();
        //disconnect();
        
        //tbind(new InetSocketAddress(8888));

    }
    
    
    private void startListening(){
        
        //this method listens for incoming key stroke packets
        
        //output socket status
        System.out.print("is the socket bound:" + isBound() + " port=" + getPort() + " local port =" + getLocalPort() + "\n");
                
        
        //byte[] tempbyte = new byte[40];
        
           
        DatagramPacket p = new DatagramPacket(new byte[1024],1024);
        
        //System.out.print("tempbyte is:" + tempbyte.toString() + "\n");
        System.out.print("Blocking on recieve() method...\n");
        
        while(true)
        {
            try{
                receive(p);

                int len = p.getLength();
                String s = new String(p.getData(),0,len);
                
                parsePacket(s,p.getAddress().getHostAddress());
                
                //moveAllSnakesAndSendAllCurrentGameData();
                //System.out.print("got a packet from:" + p.getAddress().getHostAddress() + " length=" + len + " data=" + s + "\n");

            }
            catch(Exception E){
                System.out.print("ERRORCould not recieve Datagrampacket.");
            }
        }
        
        
    }
    public void parsePacket(String s, String snakeIP)
    {
        //parse the packet based on the type of mesage
        if(s.charAt(0) == 'd')
        {
            //it is a direction change message
            snakematrix.changeDirection(snakeIP, Integer.valueOf(s.substring(1, 2)));
            
        }
        
    }
    public void run()
    {
  
        //start listeing for an incoming connection
        startListening();
        
        
        
    }
    
    public void moveAllSnakesAndSendAllCurrentGameData()
    {
        snakematrix.moveAllSnakes();
        sendSnakeData();
        sendFoodData();
    }
    public void sendFoodData(){
        String foodMsg = "f" + ",";
        foodMsg += snakematrix.food.size() + ","; //numsnakes
        
        for(int x=0;x<snakematrix.food.size();x++)
        {
            SnakePiece curFood = (SnakePiece)snakematrix.food.get(x);
            foodMsg += curFood.x + "-" + curFood.y + ",";
        }
        sendDataToAllClients(foodMsg);
    }
    
    public void sendSnakeData(){
        //send snakes message
        String snakeMsg = "s" + ",";
        snakeMsg += snakematrix.numsnakes + ","; //numsnakes
        
        for(int cursnake=0;cursnake < snakematrix.numsnakes; cursnake++)
        {
            snakeMsg += snakematrix.snakes[cursnake].getSize() + ",";
            for(int curpiece=0;curpiece < snakematrix.snakes[cursnake].getSize(); curpiece++)
            {
                SnakePiece sp = snakematrix.snakes[cursnake].getSnakePiece(curpiece);
                snakeMsg += sp.x + "-" + sp.y + ",";
            }
            
            
        }
        
        sendDataToAllClients(snakeMsg);
    }
    
    public void sendDataToAllClients(String s){
        int length = s.length();
        byte [] tb = new byte[s.length()];
        tb = s.getBytes();
        for(int cursnake=0;cursnake < snakematrix.numsnakes; cursnake++)
        {
                     
            try{
                InetAddress temp = InetAddress.getByName(snakematrix.snakes[cursnake].ip);   
                DatagramPacket p = new DatagramPacket(tb,length,temp, 30061);
                send(p);
            }
            catch(Exception e){
                int foobar = 0;
            }
        }
    }
}
